%define current_version 7.0.144

Name: vcmmd
Version: %{current_version}
Release:        1%{?dist}
Summary: Virtuozzo memory management daemon
Group: System Environment/Base
License: GPLv2
Source: %{name}-%{version}.tar.bz2

Requires: python2 >= 2.7
Requires: python-daemon
Requires: python-psutil
Requires: dbus-python
Requires: pygobject2
Requires: libvirt-python

BuildRequires: gcc-c++ >= 4.7
BuildRequires: python2-devel >= 2.7

ExclusiveArch: x86_64

Conflicts: ksm

%description
vcmmd is a daemon that watches Virtuozzo containers and tunes their memory
configuration parameters according to the current memory demand.

%prep
%setup -q -n vcmmd-%{version}

%build
%{__python} setup.py build

%install
%{__python} setup.py install -O1 --skip-build --root %{buildroot} --install-scripts %{_sbindir}

%post
%systemd_post vcmmd.service

%preun
%systemd_preun vcmmd.service

%postun
%systemd_postun_with_restart vcmmd.service

%files
%python_sitearch/vcmmd
%python_sitearch/vcmmd-%{version}-py?.?.egg-info
%{_sbindir}/vcmmd
%{_sbindir}/vcmmdctl
%{_unitdir}/vcmmd.service
/etc/logrotate.d/vcmmd
/etc/dbus-1/system.d/com.virtuozzo.vcmmd.conf
/etc/vz/vcmmd.d/vz
%config(noreplace) /etc/vz/vcmmd.conf
%config(noreplace) /etc/vz/vstorage-limits.conf

%changelog
* Tue May 23 2017 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.144
 - version bump to 7.0.143

* Tue May 23 2017 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.143
 - switch to numa_migrate for CT (#PSBM-61969)

* Wed Apr 12 2017 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.140
 - add workaround to disable tcache for vstorage (#PSBM-64068)
 - add option for error message in get_rss

* Thu Mar 16 2017 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.139
 - add forgotten read to low memory event handler (#PSBM-62266)

* Mon Mar 13 2017 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.138
 - Update copyrights (Andrey Bondrov <abondrov@virtuozzo.com>)

* Thu Mar 02 2017 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.137
 - Add rebranding macroses, see #PSBM-58317 (Konstantin Volkov
<wolf@virtuozzo.com>)
 - Drop systemd unit installation - moved to sources, see #PSBM-58317
(Konstantin Volkov <wolf@virtuozzo.com>)

* Tue Feb 28 2017 Konstantin Volkov <wolf@virtuozzo.com> 7.0.136-2
- Drop systemd unit installation - moved to sources, see #PSBM-58317

* Wed Feb 15 2017 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.136
 - not rely to libvirt version when parse qemu cmdline (#PSBM-60274)
 - catch Error exception in nr_cpus & set_config (#PSBM-60274)
 - vz script swap and vram zero-value fix (Derbyshev Dmitry
<dderbyshev@virtuozzo.com>)

* Mon Feb 06 2017 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.135
 - set-policy fixes (Derbyshev Dmitry <dderbyshev@virtuozzo.com>) (#PSBM-59885)
 - minor cleanup
 - path for vstorage

* Thu Jan 26 2017 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.134
 - dont update stats on deactivate (#PSBM-59222)

* Tue Jan 24 2017 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.133
 - remove workers
 - remove request decorator
 - log possible typos and missing cgroups (Derbyshev Dmitry
<dderbyshev@virtuozzo.com>) (#PSBM-58041)
 - print script's stdout (Derbyshev Dmitry <dderbyshev@virtuozzo.com>) (#PSBM-58041)

* Tue Jan 17 2017 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.132
 - Common format for services config fix (Derbyshev Dmitry
<dderbyshev@virtuozzo.com>) (#PSBM-58041)

* Mon Jan 16 2017 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.131
 - Common format for services config (Derbyshev Dmitry
<dderbyshev@virtuozzo.com>) (#PSBM-58041)

* Thu Jan 12 2017 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.130
 - vcmmdctl current-policy rework (Derbyshev Dmitry <dderbyshev@virtuozzo.com>) (#PSBM-58420)
 - vcmmdctl get-current-policy renamed to current-policy (Derbyshev Dmitry
<dderbyshev@virtuozzo.com>) (#PSBM-58420)
 - GetPolicyFromFile dbus call added (Derbyshev Dmitry
<dderbyshev@virtuozzo.com>) (#PSBM-58420)
 - pass config filename during VCMMDConfig creation (Derbyshev Dmitry
<dderbyshev@virtuozzo.com>) (#PSBM-58420)
 - log args for functions called via dbus (Derbyshev Dmitry
<dderbyshev@virtuozzo.com>) (#PSBM-58015)

* Thu Dec 29 2016 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.129
 - add cli for policy switching (#PSBM-57909)
 - move json load under try
 - fix max guarantee size for vstorage

* Thu Dec 22 2016 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.128
 - fix ram_size in vz script
 - update default guarantee in update_ve_config
 - fix syntax error
 - set auto guarantee for VM in vcmmd (#PSBM-55018)
 - handle ValueError in vstorage-config parse

* Tue Dec 20 2016 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.127
 - add vstorage config to setup.py

* Tue Dec 20 2016 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.126
 - update file list in .spec (#PSBM-57684)

* Tue Dec 20 2016 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.125
 - move vstorage limits in separate config (#PSBM-57684)
 - dont set node list if nodes is None

* Mon Dec 19 2016 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.124
 - try to pin VE on each step of balance
 - remove set_memstats_period in init VM

* Mon Dec 19 2016 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.123
 - subscribe balloon policy to low memory notification
 - fix block stats
 - fix count name
 - fix exception handling

* Wed Dec 14 2016 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.122
 - cosmetic fix in numa migration accounting
 - don't fail if we already deactivated in counter increment
 - dont lookup qemu pid each get_rss call

* Wed Dec 14 2016 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.121
 - add get_rss (#PSBM-57330)

* Tue Dec 13 2016 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.120
 - add low memory evens count to policy stats
 - minor cosmetic fix
 - drop VE from stats on deactivate

* Tue Dec 13 2016 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.119
 - fix apply_changes (#PSBM-57023)
 - increase epoll timeout (#PSBM-57023)
 - polling by EPOLLIN flag (#PSBM-57023)
 - add policy.shutdown in load manager (#PSBM-57023)
 - add workaround to avoid notification flood (#PSBM-57023)
 - add numa_low_memory_callback to base NUMA policy (#PSBM-57023)
 - rework low memory callback registration (#PSBM-57023)
 - add low memory notification (#PSBM-57023)

* Thu Dec 08 2016 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.118
 - set memory_migrate before set affinity

* Thu Dec 08 2016 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.117
 - dont re-set affinity if it's not changed (#PSBM-56357)
 - dont use numa_migrate for ct (#PSBM-56643)

* Thu Dec 08 2016 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.116
 - lookup and activate vstorage slice in vz script (#PSBM-49711 #PSBM-48754)

* Tue Dec 06 2016 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.115
 - fix report ksm/numa policy in config (#PSBM-55578)

* Tue Dec 06 2016 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.114
 - disable balloon policy by defautl
 - avoid THP scanning in the guest (Derbyshev Dmitry <dderbyshev@virtuozzo.com>) (#PSBM-55578)
 - misc. fixes (Derbyshev Dmitry <dderbyshev@virtuozzo.com>)
 - avoid KSM scanning in the guest (Derbyshev Dmitry <dderbyshev@virtuozzo.com>) (#PSBM-55578)
 - cpu_features added (Derbyshev Dmitry <dderbyshev@virtuozzo.com>) (#PSBM-55578)

* Fri Dec 02 2016 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.113
 - increase oom guarantees for system.slice (#PSBM-56347)

* Thu Dec 01 2016 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.112
 - log dbus requests (Derbyshev Dmitry <dderbyshev@virtuozzo.com>)
 - Revert "log bdus requests" (Derbyshev Dmitry <dderbyshev@virtuozzo.com>)

* Tue Nov 29 2016 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.111
 - fix policy counters (#PSBM-56090)

* Mon Nov 28 2016 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.110
 - catch NoSuchProcess in lookup_qemu_machine_pid (#PSBM-56026)

* Mon Nov 28 2016 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.109
 - use memory.numa_migrate for pinning CT memory (#PSBM-54455)
 - Revert "temporary remove guaranty type from config"

* Tue Nov 22 2016 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.108
 - fix update stats for vm (#PSBM-52255)
 - fix check name in ve/base (#PSBM-49711)
 - log bdus requests (Derbyshev Dmitry <dderbyshev@virtuozzo.com>) (#PSBM-55150)

* Sun Nov 20 2016 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.107
 - remove numa_enforce_settings from activete/set_config
 - temporary remove guaranty type from config (#PSBM-55597)

* Fri Nov 18 2016 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.106
 - pretty output for get_current_policy (Derbyshev Dmitry
<dderbyshev@virtuozzo.com>) (#PSBM-55022)
 - add guarantee_type to ve config (#PSBM-49129 #PSBM-55018)
 - add numa_configured check for VEs (Derbyshev Dmitry
<dderbyshev@virtuozzo.com>) (#PSBM-53459)
 - fix logic in ve_config nodelist and cpulist default values (Derbyshev Dmitry
<dderbyshev@virtuozzo.com>)

* Thu Nov 17 2016 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.105
 - do not get unapplied values from prl-disp config in vz script (Derbyshev
Dmitry <dderbyshev@virtuozzo.com>) (#PSBM-55034)

* Tue Nov 15 2016 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.104
 - split CT class (#PSBM-49711)

* Tue Nov 15 2016 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.103
 - add nr_cpus field (Derbyshev Dmitry <dderbyshev@virtuozzo.com>) (#PSBM-51444)

* Fri Nov 11 2016 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.102
 - ignore empty nodes (#PSBM-55090)

* Thu Nov 10 2016 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.101
 - BUGFIX Teach vcmmd to tolerate empty NUMA node list #PSBM-55090 Previous
commit 21f9e69ad017c2981047ee2db8c1d7eb011d47b7 was intended to fix this, but it
would work for lines containing whitespace characters, thus replacing "not" with
"isspace()" call. (Pavel Vokhmyanin <pvokhmyanin@virtuozzo.com>)
 - set cgroup limits on CT's registration (Derbyshev Dmitry
<dderbyshev@virtuozzo.com>) (#PSBM-54957)
 - move ve.active check to update_ve_config (Derbyshev Dmitry
<dderbyshev@virtuozzo.com>) (#PSBM-54957)
 - common code for policies moved to policy.py (Derbyshev Dmitry
<dderbyshev@virtuozzo.com>) (#PSBM-54957)

* Tue Nov 08 2016 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.100
 - catch libvirt error in set_node_list

* Mon Nov 07 2016 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.99
 - add thptune option for host
 - cgroup limit_in_bytes value correctly changed after CT restore (Derbyshev
Dmitry <dderbyshev@virtuozzo.com>) (#PSBM-54719)

* Thu Nov 03 2016 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.98
 - use aliace "performance" in config
 - move unpin ve to policy
 - Revert "get ves list in update_ve"
 - get ves list in update_ve

* Tue Nov 01 2016 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.97
 - add workaround for libvirt 2.4 (#PSBM-54553)
 - reset cgroups only if ve was managed by policy
 - use LIVE flag instead of CURRENT
 - don't tune memory_migrate each time
 - fix cpu number calculation

* Mon Oct 31 2016 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.96
 - add alias for policy

* Mon Oct 31 2016 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.94
 - fix vz script

* Thu Oct 27 2016 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.93
 - add node_list and cpu_list into ve_config (#PSBM-53459)
 - misc: parse_range_list on empty string
 - add support for string values in config (#PSBM-53459)

* Mon Oct 24 2016 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.92
 - add walkaround for cpu/node set (#PSBM-52315)

* Wed Oct 05 2016 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.91
 - wait for virtuozzo.target on vcmmd start in vz script (#PSBM-48046)

* Wed Sep 28 2016 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.90
 - report policy stats in vcmmdctl (#PSBM-52152)

* Tue Sep 27 2016 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.89
 - cosmetix fix
 - set memory.low for machine.slice to infinity (#PSBM-52330)

* Mon Sep 26 2016 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.88
 - cosmetix fix
 - set memory.low for machine.slice to infinity (#PSBM-52330)

* Fri Sep 16 2016 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.87
 - set_mem on config update (#PSBM-52254)

* Thu Sep 15 2016 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.86
 - fix raise in load manager queue (#PSBM-52181)

* Wed Sep 14 2016 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.85
 - Catch ve_name_already_in_use error in init script. (#PSBM-48046)

* Wed Sep 14 2016 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.84
 - add "config" option for vcmmdctl
 - move and rename cpu_counting method form numa to host module
 - fix mem stats for node
 - fix log level in set_node_list

* Mon Sep 12 2016 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.83
 - switch to new vz memory policy (#PSBM-51051)
 - mark config file as "config(noreplace)"

* Mon Sep 12 2016 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.82
 - fix raise in unregister VE vs policy processing (#PSBM-51985)
 - add restriction for nodes without NUMA (#PSBM-51051)
 - cosmetic, remove useless loging
 - remove ve_list and ve_list_all from policy (#PSBM-51051)
 - update NoOpPolicy (#PSBM-51051)
 - fix race ldmgr (#PSBM-51051)
 - fix race in stats module (#PSBM-51051)
 - rework NUMA stats collecting and storing (#PSBM-51051)
 - add vcmmd:env (#PSBM-51051)
 - fix dimensions in mem stats (#PSBM-51051)
 - add method for tune memory_migrate option (#PSBM-51051)
 - cosmetic fix (#PSBM-51051)

* Fri Sep 09 2016 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.81
 - fix import (#PSBM-51927)

* Fri Sep 09 2016 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.80
 - add "Controlles" section to config (#PSBM-51852)
 - add conflict with ksm pkg (#PSBM-47473)

* Mon Sep 05 2016 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.79
 - Add workaround for psutil<2.0.0 (#PSBM-51738)

* Tue Aug 30 2016 Konstantin Neumoin <kneumoin@virtuozzo.com> 7.0.78
 - fix error handling in ksmtune
 - stop workers by exception
 - RQueue improving
 - drop request decorator for get_quotas
 - add KSM class to policy (#PSBM-47473)
 - rework update/balance task schedule in load manager (#PSBM-47473)
 - add new RQueue class for LoadManager (#PSBM-47473)
 - add ksmtune method to Host class (#PSBM-47473)
 - fix logic in set_mem (#PSBM-47473)
 - drop set_memstats_period (#PSBM-47473)
 - split update stats methods (#PSBM-47473)
 - fix parametr type for set_node_list
 - ldmgr: NumaPolicy subclass of Policy added
 - ve: add NUMA related stats and methods from cgroups
 - rework VE method for get/set numaset (#PSBM-47472)
 - cgroups: CpuCgroup class added
 - cgroups: MemoryCgroup stat reporting functions added
 - cgroups: CpuSetCgroup added
 - numa: Numa class added
 - numa: Node and NodeStat classes added
 - numa: Cpu and CpuStat classes added
 - numa: initial commit
 - util/misc: add range list functions
 - vcmmd: multiple policies support
 - policy: keep list of all ves

* Mon Aug 08 2016 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.77
 - Add VCMMD_VE_SERVICE ve type

* Thu Jun 30 2016 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.76
 - add last_update to stats (#PSBM-48681)

* Tue Jun 28 2016 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.75
 - Add license information (#PSBM-44847)
 - Drop beancounter cgroup

* Tue Jun 28 2016 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.74
 - vcmmdctl: report ve_quotas (#PSBM-48663)
 - ve: Remember last target and protection set for each VE
 - vcmmd: report missing stats via vcmmdctl (#PSBM-46796 #PSBM-48663)

* Fri Jun 24 2016 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.73
 - introduce default balance interval for policy (#PSBM-48679)
 - move set stats update period to separate method (#PSBM-48679)

* Thu Jun 23 2016 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.72
 - default policy should be NoOp (#PSBM-48691)

* Tue Jun 21 2016 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.71
 - ve: ct: Adjust memory.high asynchronously
 - ve: ct: Drop VE.CT.SoftMemTarget config option
 - util: logging: add flush for LoggerWriter

* Mon Jun 20 2016 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.70
 - ve: ct: Handle containers under machine.slice (#PSBM-48628)

* Fri Jun 17 2016 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.69
 - take in account registered but not activate VE (#PSBM-48478)
 - increase mem overhead
 - Take in account current balloon size before set new value (#PSBM-48383)

* Thu Jun 16 2016 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.68
 - drop "commited" from stats
 - rework communication with libvirt and collect stats (#PSBM-47580)
 - util: libvirt: Carefully remove stale counters from memstats
 - fix set_mem

* Fri Jun 10 2016 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.67
 - move quota calculation to policy
 - drop StaticPlolicy

* Wed Jun 08 2016 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.66
 - ldmgr: add host parameter for balancing
 - host: initial commit
 - add vm_types to garanty dict (Konstantin Neumoin <kneumoin@virtuozzo.com>)
 - fix protection size
 - Drop unused import of Error in ve/__init__.py
 - Move VEStats to ve/base.py
 - stats: refactor stats class
 - return from set_mem immediately if desired size equal actual
 - report current policy via vcmmdctl (#PSBM-46796)

* Thu May 26 2016 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.65
 - cli: pretty output a little
 - set correct ve_type for linux/windows vm
 - add two new VM types
 - increase valid timeout for stats update

* Thu May 19 2016 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.64
 - util: libvirt: Ignore outdated memory stats from virtio balloon
 - ve: ct: Export swapin and swapout stats if available
 - ve: ct: Fix memavail calculation

* Wed May 11 2016 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.63
 - change default policy to WSS (#PSBM-46895)
 - rename DEFAULT_POLICY

* Wed May 04 2016 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.62
 - Store policy data in dict inside base class Policy

* Mon Apr 25 2016 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.61
 - add shared memory to mem_avail

* Tue Apr 19 2016 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.60
 - util: libvirt: Fix lookup qemu-kvm pid by VM name (#PSBM-46277)

* Thu Apr 14 2016 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.59
 - Zap WSS and WFB policies

* Wed Apr 06 2016 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.58
 - vcmmd:scripts/vz: bugfix for CT
 - Zap memtotal VE stats counter
 - util: libvirt: Do not log info messages on reconnect attempts
 - util: libvirt: Do not log error on connection failure

* Tue Apr 05 2016 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.57
 - scripts: vz: Fail gracefully
 - ve: Add logging helpers
 - ve: Prefix debug output with function name
 - Rename VE.update -> VE.update_stats
 - idlememscan: Drop histograms support
 - Drop numpy requirement

* Sun Apr 03 2016 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.56
 - Do not mangle VE config (#PSBM-45717)
 - cli: Fail gracefully if vcmmd service is not running
 - Add init script for restoring Virtuozzo containers and VMs (#PSBM-44917)
 - Reintroduce init script support
 - Zap saving VE configuration to tmpfs
 - Move VE related checks from vcmmd.ldmgr to vcmmd.ve
 - Do not abort VE activation if failed to apply config (#PSBM-44784)
 - cli: Do not group VE config options
 - Remove unused import ve.Error from ldmgr.base
 - Fix 'Started' not printed to log when the daemon starts
 - Add /etc/vz/vcmmd.d/vz to the package

* Wed Mar 30 2016 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.55
 - ve: ct: Fix huge memfree on container start
 - Add VE stats for host mem and swap used
 - Increase error logging verbosity
 - cgroup: Make cgroup path and abs_path public members
 - Define PAGE_SIZE in util.limits
 - wfb policy: Make sure quota is always between guarantee and limit
 - Reduce expected VM overhead from 200MB to 32MB
 - Rename config VE.VM.QEMUOverhead -> VE.VM.MemOverhead
 - Add video RAM size to VE config
 - Add flags argument to register, activate, and update operations
 - Rename NO_SPACE error to UNABLE_APPLY_VE_GUARANTEE

* Mon Mar 28 2016 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.54
 - ve: stats: Keep all stats in a dict
 - Merge MemStats and IOStats
 - Zap mem_stats.wss
 - Zap VEConfig.effective_limit
 - ve: Drop InvalidVENameError and InvalidVETypeError
 - Cleanup VE config handling
 - Use the same VE type name constants in both service and client
 - Use the same error class in both service and client
 - Replace Logging.Debug config option with Logging.Level
 - Drop -d command line option
 - Allow to set VCMMD logging level via vcmmdctl
 - Drop vcmmdctl dump
 - Supply policy with the right logger in the abstract class
 - ldmgr: Calculate mem_avail on each rebalancing
 - Take into account VE overhead when checking guarantees
 - util: libvirt: Lookup balloon path on demand
 - Rename VE.policy_priv -> policy_data
 - ldmgr: Rename update_ve -> update_ve_config
 - Add policy callback to notify about VE config updates
 - Add policy callback to notify about stats updates
 - Move active VE list management to load manager policy
 - Always return exactly -1 for absent stats
 - Increase verbosity of debug output
 - Make sure all VE stats are always present
 - Cleanup config output
 - Rename LoadManager loggers
 - Do not dump all config parameters to the log unless in debug mode
 - Move logging related to VE state changes to VE class
 - Insert assertions checking if VE is active where appropriate
 - Do not require VE.set_config after VE construction
 - Revert "ldmgr: Rate limit VE stats dumping in debug mode"
 - Remove WSSSoftPolicy
 - Rename VE.update_stats -> VE.update
 - Merge set_mem_protection and set_mem_target VE methods
 - Do not suppress error message if failed to load policy
 - Separate underlying VE implementation from VE handling logic
 - Assume that all policies need periodic stats updates
 - Drop idle VE memory tracking infrastructure
 - cgroup: memory: turn _IdleMemScanner into a singleton
 - Prefix ve types with VE_TYPE_

* Thu Mar 24 2016 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.53
 - ve: ct: Catch IOError in set_mem_target
 - Use a more reliable way to lookup QEMU machine cgroup (#PSBM-45267)
 - ve: Get rid of trivial properties
 - Prefix all vcmmd error constants with VCMMD_ERROR_
 - util: libvirt: Do not lose stack trace when re-raising error
 - Revert "Reduce QEMU process overhead estimation from 200MB down to 32MB"
 - Revert "Account KSM shared pages when calculating memory available for VEs"
 - Revert "Don't wrap libvirt attribute if it's not callable"
 - wss policy: use VE.mem_stats.memavail if available
 - Revert "wss policy: collect x-stats from balloon if its posible"
 - Add committed_as to memory stats
 - Add memavailable to memory stats
 - util: libvirt: Make memoryStats report stats unknown to libvirt/qemu
 - util: libvirt: Move connection checking to decorator
 - Factor out ve stats update
 - Report actual, memtotal, and memfree for containers
 - Rename available/unused mem stats to memtotal/memfree
 - cgroup: Do not pass full file name

* Thu Mar 17 2016 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.52
 - wss policy: init AbstractVE._actual and wss in constructor
 - wss policy: fix debug message
 - wss policy: fix constant
 - wss policy: fix policy for CT
 - ldmgr: Do not rate limit debug dumps by default
 - wss policy: do not dump ve name for the second time
 - wss policy: add report stats source for debuging
 - wss policy: collect x-stats from balloon if its posible
 - wss policy: add alias for mem stats counters
 - Don't wrap libvirt attribute if it's not callable

* Tue Mar 15 2016 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.51
 - ldmgr: Rate limit VE stats dumping in debug mode
 - Move idle memory tracking parameters to VE config section
 - ldmgr: Cleanup initialization
 - ldmgr: Zap constants for default configs
 - Unify VE stats dumping in debug mode
 - Account KSM shared pages when calculating memory available for VEs
 - Reduce QEMU process overhead estimation from 200MB down to 32MB
 - Dump all loaded config parameters to log
 - ve: vm: Move all constants to config

* Wed Mar 09 2016 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.50
 - WSSSoftPolicy: add new policy
 - WSSPolicy: rename _VEPrivate -> AbstractVE
 - WSSPolicy: fix logging

* Mon Feb 29 2016 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.49
 - Set memcg oom_guarantee for system slices (#PSBM-44683)

* Wed Feb 24 2016 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.48
 - Rename WeightedFeedbackBasedPolicy -> WFBPolicy
 - policies: Do not pass logger around
 - WSSPolicy: additional logging for trace problem in policy
 - config: Cache retrieved values
 - config: Cleanup option values retrieval
 - Move load manager parameters to config
 - Rework calculation of host memory reservation
 - Drop code enabling tcache/tswap
 - Use memcg/memory.high for setting memory target for containers
 - Set memcg/memory.oom_guarantee for VMs and CTs (#PSBM-44450)
 - ve: Zap _set_mem_max, _set_swap_max
 - Add command to dump info about all running VEs to the log
 - Add pygobject2 and libvirt-python to dependency list (#PSBM-44062)

* Wed Feb 10 2016 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.47
 - add new ve propery memory overhead (#PSBM-40830)
 - WSSPolicy: add support for CT

* Sun Feb 07 2016 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.46
 - Allow to set debug logging level via config
 - policies: wfdbk: Fix div/0 (#PSBM-43855)
 - split logic for diff guests in diff classes

* Tue Feb 02 2016 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.45
 - vcmmd:WSSPolicy: fix gap calculation
 - vcmmd:WSSPolicy: move align to decorator
 - vcmmd:WSSPolicy: set default guest type
 - Escape name of VM machine slice cgroup properly (#PSBM-43766)
 - ve: Simplify error reporting
 - cli: Output decimal places of mem value only if it's small

* Mon Feb 01 2016 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.44
 - rpc: dbus: Add IsVEActive method

* Mon Feb 01 2016 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.43
 - Make sure daemon terminates on unhandled exception
 - cli: Drop the semicolon in output
 - cli: Allow to specify units in which memory values are reported
 - ldmgr: Fix crash in case VE state file is corrupted (#PSBM-43660)

* Fri Jan 29 2016 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.42
 - policies:WSSPolicy: add support linux guest in policy
 - policies:WSSPolicy: add VmGuestSession class for exec in guest
 - policies:WSSPolicy: fix delta calculation
 - Rename config file to /etc/vz/vcmmd.conf
 - Drop init scripts support
 - ldmgr: Move complex init to worker thread
 - ldmgr: Store VE configuration in tmpfs (#PSBM-43114)
 - rpc: dbus: Assure all input arguments are of normal Python types
 - Improve message for NO_SPACE error
 - Improve message for invalid VE configuration error
 - Update file list

* Thu Jan 28 2016 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.41
 - ldmgr: Allow policy to disable features it does not need
 - policies: wfdbk: Fix thrashing detection (#PSBM-43582)

* Wed Jan 27 2016 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.40
 - vm: Roundup hotplug memory to 128MiB (#PSBM-43290)
 - policies: wfdbk: Scale unused by quota, not limit
 - policies: wfdbk: Dump VE stats in debug mode
 - Resurrect no-op policy
 - ldmgr: Increase host reservation on small machines
 - policies: wfdbk: make sure sum quota <= mem avail
 - ldmgr: Allow policy to return quotas whose sum > mem avail
 - ldmgr/ve: Do not save last quota
 - vcmmd:ldmgr:policies:WSSPolicy: increasing balloon size should not be too
fast (#PSBM-40757)
 - Add new policy WSSPolicy (#PSBM-40757)
 - vcmmd:ve:vm: add new field for guest mem stats (#PSBM-40757 #PSBM-40013)

* Tue Jan 26 2016 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.39
 - rpc: dbus: Add GetVEConfig method
 - cli: Rename --guar to --guarantee
 - Do not import load manager code when running client
 - Move errno to upper level
 - rpc: dbus: Split into client and server parts
 - Encapsulate rpc proxy code in vcmmd.rpc.dbus.RPCProxy

* Fri Jan 22 2016 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.38
 - ldmgr: Fix broken policies package
 - ldmgr: Remove stale import

* Fri Jan 22 2016 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.37
 - Allow to choose load manager policy via config parameter
 - Add config file
 - Add singleton metaclass
 - Include vcmmd config into the package

* Wed Jan 20 2016 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.36
 - ct: Set udp/tcp limits
 - ct: Do not use memory.high for setting memory target
 - ve: Do not provide MemStats.actual for containers
 - ve: Fix comment to ve.Config.guarantee
 - ve: Print Error class name to log
 - ve: Drop VE_TYPE_NAME
 - Add libvirt reconnect support

* Wed Jan 20 2016 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.35
 - policies: wfdbk: Avoid div/0 due to zero quota
 - policies: wfdbk: Assure quota is always an integer
 - Add logger to Policy class
 - Cleanup daemon main function code
 - Make logging per module
 - Add gitignore

* Tue Jan 19 2016 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.34
 - Use host memory size as the limit for 'unlimited' containers
 - Do not fail to start 'unlimited' containers
 - cli: Report limit >= INT64_MAX as 'max'
 - Restore VZ containers on startup
 - Allow to run custom scripts on daemon startup
 - Cleanup logging functions invocation
 - Cleanup rpc server code
 - Include VZ startup script into the package

* Thu Jan 14 2016 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.33
 - policies: wfdbk: Increase VE quotas in case there is free memory

* Wed Jan 13 2016 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.32
 - Drop force argument to register and update VE operations
 - Enable tcache/tswap
 - Configure memory reservations for system slices
 - Introduce weighted feedback-based policy
 - VM: modify setting memory function to use appropriate libvirt API
 - cgroup: Fix idle memory portion reporting
 - Move VE register/update guarantee check to the load manager core
 - Rework load manager balancing procedure
 - Do not pass inactive VEs to load manager policy's balance method
 - Make load manager pass available memory size to policy
 - ve: Zap __need_apply_config
 - ve: Add method for getting idle memory estimate
 - Rework memory cgroup idle stats getter API
 - Simplify interface for configuring current memory allocation of a VE
 - Elaborate VE statistics
 - cgroup: Make read/write helpers 'protected'
 - Fetch IO statistics for virtual machines
 - Fetch IO statistics for containers
 - Add helper class to work with blkio cgroups
 - Introduce VE IO statistics
 - Always force absolute_import
 - Introduce static load manager policy
 - Improve comment to no-op load manager policy
 - Introduce idle memory tracking for memory cgroups
 - Fix systemd service missing Install section (Ashley
<ashley@victorianfox.com>)
 - ve: Add more comments to the code
 - ve: Make set_mem_{low,high,max}, and set_swap_max methods 'protected'
 - Update spec file for building idlememscan

* Tue Dec 29 2015 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.31
 - cli: Increase number of symbols for name to accomodate UUID
 - Check that VE memory cgroup exists on activation
 - Reference VMs by UUID instead of name

* Tue Dec 29 2015 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.30
 - Replace CommitVE method with ActivateVE and DeactivateVE
 - ve/vm: Move libvirt memory stats activation to commit stage
 - Implement basic guarantee check on VE registration and config update
 - Move RPC code to a separate package
 - Split util module
 - s/overwrite/override in comments
 - Rename ElementaryPolicy to NoOpPolicy
 - Update VE stats before checking if a VE can be registered/updated
 - Allow load manager policy to trigger rebalancing after timeout
 - Implement set_mem_low method for virtual machines
 - Fetch memory statistics for virtual machines
 - Fetch memory statistics for containers
 - Introduce VE memory statistics
 - Improve command line interface
 - Require python-psutil

* Fri Dec 25 2015 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.29
 - Drop max_limit config parameter

* Thu Dec 24 2015 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.28
 - Add basic support of VMs

* Thu Dec 24 2015 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.27
 - Rework vcmmd so as it could support both VMs and CTs. This zaps all existing
   logic. It will be recovered later.

* Mon Nov 30 2015 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.26
 - config: tune {ANON,FILE}_WS_SLACK default values

* Sun Nov 29 2015 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.25
 - memcg: fix high demand detection

* Sun Nov 29 2015 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.24
 - base: do not inform about loading/saving state unless debugging
 - memcg: reserve some memory for system.slice and user.slice
 - config: rename MEM_IDLE_SAMPLING_RATIO -> MEM_IDLE_SAMPLING
 - config: drop MEM_IDLE_THRESH
 - config: drop HIGH_WMARK_{RATIO,MAX}

* Fri Nov 27 2015 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.23
 - idlemem: always warn about scanner lags
 - config: warn about unknown options
 - config: do not try to load config if there is no such section
 - config: use error log level for reporting config loading problems
 - config: do not warn about absent options
 - main: allow to specify config section to load
 - memcg: allow to disable dynamic balancing
 - memcg: make MemCg class private
 - Rename core -> base

* Fri Nov 27 2015 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.22
 - idlememscan: fix crash on kpageflags/kpagecgroup read
 - idlememscan: improve rw error reporting
 - config: fix {ANON,FILE}_WS_SLACK names in the conf file
 - config: sanitize config parameters
 - memcg: fix MEM_STALE_SHIFT usage
 - memcg: use MEM_TOTAL as max limit
 - memcg: cache effective entitiy limit

* Fri Nov 20 2015 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.21
 - config: tune parameters related to wss estimation once more
 - memcg: smooth dip of wss curve
 - memcg: cleanup __update_demand

* Wed Nov 18 2015 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.20
 - systemd: enable coredump generation
 - memcg: propagate IOError.errno to Error
 - core: do not output errcode on error
 - vcmmdctl: improve error reporting

* Mon Nov 16 2015 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.19
 - Restart vcmmd.service on upgrade

* Mon Nov 16 2015 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.18
 - memcg: fix debug output
 - util: make strmemsize output len <= 5 chars
 - memcg: fix distribution when undercommitted
 - memcg: make overcommitted case distribution fair

* Sat Nov 14 2015 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.17
 - memcg: fix sum demand overflow for unlimited containers
 - memcg: cache some config params
 - util: strmemsize: add Gigabyte suffix
 - core: fix LoadConfig.strmemsize output for unlimited containers

* Fri Nov 13 2015 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.16
 - memcg: rename wss -> demand
 - memcg: take into account pgpgin while estimating max wss
 - sysinfo: reintroduce PAGE_SIZE
 - config: tune idle/stale age defaults

* Thu Nov 12 2015 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.15
 - idlememscan: fix leak of PyArray data in py_result
 - idlememscan: pack results for anon/file in tuple
 - idlememscan: do not include root to the final result

* Thu Nov 12 2015 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.14
 - memcg: do not calculate memcg path on each read/write
 - memcg: optimize wss estimation
 - util: add constants for int64/uint64 max
 - memcg: fix effect of {ANON,FILE}_IDLE_AGE config
 - core/memcg: allow to register nested cgroups
 - idlemem: optimize result generation
 - Require numpy

* Mon Nov 09 2015 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.13
 - core: fix crash on unregistering stale entities (#PSBM-41097)
 - main: return non-zero on failure

* Fri Nov 06 2015 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.12
 - idlememscan: fix idle mem tracking thread breakage in daemon mode

* Thu Nov 05 2015 Konstantin <wolf@parallels.com> 7.0.9
 - Move to src.openvz.org

* Thu Nov 05 2015 Vladimir Davydov <vdavydov@virtuozzo.com> 7.0.8
 - idlemem: do not warn about small lags
 - idlememscan: cleanup MAX_AGE definition
 - memcg: add min for idle age
 - memcg: limit max age
 - memcg: improve debug output
 - rpc: do not dump request/response to log
 - config: use logger.info to inform about loading config
 - core: use logger.info to inform about loading/saving state
 - memcg: rework balancing logic
 - memcg: zap BaseMemCgManager.__init__
 - memcg: rename TRACK_UNUSED_MEM -> TRACK_IDLE_MEM
 - memcg: update mem_unused only when idle_stat is actually updated
 - core: add AbstractLoadManager._entity_iter method
 - idlemem: do not crash if failed to load idlememscan
 - config: set MEM_IDLE_DELAY default to 5 seconds
 - memcg/idlemem: use sampling while estimating idle memory size
 - config: cleanup and simplify config loading
 - sysinfo: lookup memcg mount at runtime
 - memcg: drop MAX_RESERVATION
 - config: do not abuse sections
 - idlemem: warn once if lagging
 - idlemem: do not dump idle size estimates to log
 - memcg: scale idle size instead of using absolute values
 - idlememscan: return result in bytes
 - idlememscan: do not count unevictable pages
 - idlememscan: handle module load error gracefully
 - idlememscan: do not reopen files on each iter
 - idlememscan: add ability to set sampling
 - idlememscan: return full idle history
 - idlememscan: parse zoneinfo to get end pfn
 - idlememstat: count total number of pages scanned
 - Rename kpageutil -> idlememscan
 - idlemem: move most of scanner logic to kpageutil
 - memcg: move idle mem tracking in a separate module
 - util: add Singleton decorator
 - memcg: do not trigger update periodically
 - kpageutil: track idle page age history
 - kpageutil: /proc/kpageidle -> /sys/kernel/mm/page_idle/bitmap
 - kpageutil: rename kpf_{open,read,write} to do_{open,read,write}
 - kpageutil: clarify count_idle_pages return type
 - kpageutil: rename count_idle_pages_per_cgroup to count_idle_pages
 - kpageutil: pass format string to PyErr_Format

* Fri Jun 26 2015 Vladimir Davydov <vdavydov@parallels.com> 7.0.7
 - memcg: set sock buf limit
 - memcg: limit container memory demand to host RAM
 - memcg: set mem high to MAX_LIMIT if mem limit equals MAX_LIMIT
 - core: fix LoadConfig.MAX_LIMIT

* Wed Jun 10 2015 Vladimir Davydov <vdavydov@parallels.com> 7.0.6
 - Fix coding style
 - memcg: zap memory guarantees
 - memcg: set memory.high
 - config: move idle tracking params to memcg section
 - memcg: drop memory.low_limit_in_bytes support

* Mon May 25 2015 Vladimir Davydov <vdavydov@parallels.com> 7.0.5
 - config: set core.mem_inuse_time to 300 by default
 - memcg: use memory.low if available

* Fri May 22 2015 Vladimir Davydov <vdavydov@parallels.com> 7.0.4
 - core: improve logging format of memory values
 - main: handle RPCServer init error properly
 - cli: allow to use common suffixes for memory parameters
 - cli: do not reset parameter to default if not given
 - memcg: allow to disable idle mem tracking from config

* Mon May 18 2015 Vladimir Davydov <vdavydov@parallels.com> 7.0.3
 - core/memcg: improve debug output
 - core: trigger load update periodically
 - memcg: account mem_usage decrease in mem_unused
 - memcg: use buffer when reading/writing
 - memcg: rename methods reading/writing memcg files
 - core: get rid of entity's check method
 - core: assure entity id is str
 - core: add load entity's update/sync methods
 - memcg: move error handling to __read/__write
 - core: move reset method from load manager to load entity
 - core: zap AbstractLoadEntity.__str__
 - core: convert AbstractLoadEntities.{id,config} from methods to variables
 - memcg: cleanup MemCg methods
 - core: rename AbstractLoadEntity.update_config -> set_config
 - memcg: reset entity low limit on unregister and shutdown
 - memcg: never raise exception from _do_update
 - memcg: ignore guarantees if they canno be fulfilled
 - memcg: reserve some mem for the system
 - config: move some memcg options to core section
 - memcg: move min_unused_mem to config
 - memcg: enhance low limit calculation logic
 - sysinfo: add MEM_TOTAL
 - sysinfo: close /proc/zoneinfo in _get_end_pfn()

* Thu May 14 2015 Vladimir Davydov <vdavydov@parallels.com> 7.0.2
 - memcg: do not fail if idle memory tracking is not avalable
 - memcg: take unused memory size into account
 - memcg: do not set low limit in update_config
 - Add basic tcache/tswap support
 - memcg: fix div/0 in UnusedMemEstimator.__throttle
 - kpageutil: update /proc/kpageidle handling
 - kpageutil: disable buffering before opening stream
 - kpageutil: kpf_open: rename pfn -> pos
 - kpageutil: kpf_read/write: let n be num elements in buf

* Mon Apr 27 2015 Vladimir Davydov <vdavydov@parallels.com> 7.0.1
 - Initial version

